/****************************************************************************
**
** Copyright (C) 2006-2009 fullmetalcoder <fullmetalcoder@hotmail.fr>
**
** This file is part of the Edyuk project <http://edyuk.org>
** 
** This file may be used under the terms of the GNU General Public License
** version 3 as published by the Free Software Foundation and appearing in the
** file GPL.txt included in the packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#include "qdesigneractioneditor.h"

#include "qdesignerperspective.h"

#include <QDesignerComponents>

#include <QDesignerActionEditorInterface>
#include <QDesignerFormEditorInterface>
#include <QDesignerFormWindowInterface>
#include <QDesignerFormWindowManagerInterface>

QDesignerActionEditor::QDesignerActionEditor(QDesignerPerspective *p)
 : QDockWidget(0), pParent(p), pForm(0)
{
	setWindowTitle(tr("Actions"));
	setObjectName("x-designer/actioneditor");
	
	pInterface = QDesignerComponents::createActionEditor(p->handler(), this);
	
	connect(p->handler()->formWindowManager(),
			SIGNAL( activeFormWindowChanged(QDesignerFormWindowInterface*) ),
			this,
			SLOT  ( formChanged(QDesignerFormWindowInterface*) ) );
	
	
	setWidget(pInterface);
	
	p->handler()->setActionEditor(pInterface);
}

QDesignerActionEditor::~QDesignerActionEditor()
{
	
}

void QDesignerActionEditor::retranslate()
{
	setWindowTitle(tr("Actions"));
}

void QDesignerActionEditor::formChanged(QDesignerFormWindowInterface *w)
{
	pForm = w;
	pInterface->setFormWindow(pForm);
}
